#!/bin/sh

. /var/log/copfilter/default/etc/global_settings
. /var/ipcop/main/settings
. /var/log/copfilter/default/langs/en.sh
. /var/log/copfilter/default/langs/${LANGUAGE}.sh



NOTIF2=/var/log/copfilter/default/etc/cp_spam_whitelist/email_addresses_for_spam_notifications
NOTIF=/var/log/copfilter/default/opt/tmp/notif.$$
NONOTIF=/var/log/copfilter/default/opt/tmp/nonotif.$$

rm -f /var/log/copfilter/default/opt/tmp/spam_digest*

cat $NOTIF2 | grep "whitelist_from" |awk '{print $2}' |sed 's/^\*//g' |sed 's/^@\*//g' >$NOTIF
cat $NOTIF2 | grep "blacklist_from" |awk '{print $2}' |sed 's/^\*//g' |sed 's/^@\*//g' >$NONOTIF

echo "notification will be sent to"
cat $NOTIF
echo "nonotif"
cat $NONOTIF



TMP_FILE1=/var/log/copfilter/default/opt/tmp/tmpfile1.$$


cd /var/log/copfilter/default/opt/p3scan/quarantine

#for EMAIL in `find $BASEDIR/opt/p3scan/quarantine/*.spam $BASEDIR/opt/proxsmtp/quarantine/*.spam -type f -mtime -1`
#fix from jens
for EMAIL in `find $BASEDIR/opt/p3scan/quarantine/ $BASEDIR/opt/proxsmtp/quarantine/ -mtime -1 |grep ".spam$"`
do
    RECIPIENTS2=`cat $EMAIL |sed -n '1,/^$/p' | $BASEDIR/opt/tools/bin/formail -c | \
                 /usr/bin/awk -f $BASEDIR/opt/tools/bin/extract_email_adresses_to.awk`
    RECIPIENTS=`echo $RECIPIENTS2 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/' | cut -d " " -f 1`
    SENDER2=`cat $EMAIL |sed -n '1,/^$/p' | $BASEDIR/opt/tools/bin/formail -b -f -c | \
                 /usr/bin/awk -f $BASEDIR/opt/tools/bin/extract_email_adresses_from.awk`
    SENDER=`echo $SENDER2 |sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
#    SUBJECT=`cat $EMAIL |sed -n '1,/^$/p' |grep -i "Subject:" -m 1`
     SUBJECT=`cat $EMAIL |sed -n '1,/^$/p' |grep -i "^Subject:" -m 1`

    for i in `cat $NOTIF`
    do
        echo $RECIPIENTS |grep -i "$i" &>/dev/null
        RESULT=$?
        if [ "x${RESULT}" = "x0" ];then
            #echo
            #echo EMAIL $EMAIL
            #echo DIGESTER $i
            #echo SENDER $SENDER
            echo Sender:  $SENDER >>/var/log/copfilter/default/opt/tmp/spam_digest.$RECIPIENTS
            echo "$SUBJECT" >>/var/log/copfilter/default/opt/tmp/spam_digest.$RECIPIENTS
            echo >>/var/log/copfilter/default/opt/tmp/spam_digest.$RECIPIENTS
        fi
    done

done

for k in `cat $NONOTIF`
do
    rm /var/log/copfilter/default/opt/tmp/spam_digest.$k
done

#test -f /var/log/copfilter/default/opt/tmp/spam_digest.* || rm /var/log/copfilter/default/opt/tmp/*not* && exit 0
if [ $(ls /var/log/copfilter/default/opt/tmp/ | grep spam_digest.* | wc -w) = 0 ]; then
	rm /var/log/copfilter/default/opt/tmp/*not* >/dev/null 2>&1
	exit 0
fi

#for ii in `ls /var/log/copfilter/default/opt/tmp/spam_digest.* &>/dev/null`
for ii in `ls /var/log/copfilter/default/opt/tmp/spam_digest.*`
do

    echo "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-" > $TMP_FILE1
    echo >> $TMP_FILE1
    echo "$CP_spam_digest" >> $TMP_FILE1
    echo >> $TMP_FILE1
    echo >> $TMP_FILE1
    echo "$CP_spam_digest2" >> $TMP_FILE1
    echo "$CP_spam_digest3" >> $TMP_FILE1
    echo >> $TMP_FILE1
    echo >> $TMP_FILE1
    cat  $ii >>$TMP_FILE1

    #################### RECAP for admin ################
    cat  $ii >> /tmp/DAILY_RECAP	
    ###################################"#################		

    USER=`echo $ii | sed -e 's/\/var\/log\/copfilter\/default\/opt\/tmp\/spam_digest\.\(.*\)/\1/'`

#        if [ -f $BASEDIR/etc/smtp_auth_enable ]; then
        if [ "x${SMTP_AUTH_ENABLE}" = "xon" ]; then
                echo "smtp authentication enabled, using user: $SMTP_AUTH_USER"
                cat $TMP_FILE1 | $SENDEMAIL -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                                -f $SENDER_ADR -t $USER -s "${SMTP_HOST}"  \
                                -u "[Copfilter] Daily Spam Digest" |logger -t "sendemail spam digest"
        else
                cat $TMP_FILE1 | $SENDEMAIL -f $SENDER_ADR -t $USER -s "${SMTP_HOST}"  \
                                -u "[Copfilter] Daily Spam Digest" |logger -t "sendemail spam digest"

        fi

done



#################### RECAP for admin ################
        if [ "x${SMTP_AUTH_ENABLE}" = "xon" ]; then
                echo "smtp authentication enabled, using user: $SMTP_AUTH_USER"
                cat /tmp/DAILY_RECAP | ${SENDEMAIL} -xu $SMTP_AUTH_USER -xp $SMTP_AUTH_PASS \
                                -f ${SENDER_ADR} -t ${EMAIL_ADR} -s "${SMTP_HOST}"  \
                                -u "[Copfilter] Daily Spam Digest" |logger -t "sendemail spam digest"
        else
	        cat /tmp/DAILY_RECAP | ${SENDEMAIL}  ${SENDEMAIL_OPTIONS} -f ${SENDER_ADR} -t ${EMAIL_ADR} -s "${SMTP_HOST}" \
		 -u "[Copfilter] Daily Spam Digest" |logger -t "sendemail spam digest"
	fi
######################################################		 	



rm -f /var/log/copfilter/default/opt/tmp/spam_digest*
rm -f $TMP_FILE1
rm $NOTIF
rm $NONOTIF
rm /tmp/DAILY_RECAP
